<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=iso-8859-1">
<title>iCelGameFactory Struct Reference (CEL: Crystal Entity Layer 2.0 Public API Reference)</title>
<link href="tabs.css" rel="stylesheet" type="text/css">
<link href="doxygen.css" rel="stylesheet" type="text/css">
</head><body>
<table border="0" cellpadding="0" cellspacing="0" width="100%" class="head">
 <tr height="59">
  <td class="head" width="202" valign="bottom" style="padding-left:0;"><a href="http://cel.crystalspace3d.org/"><img src="celblur.png" width="210" height="59" alt="CEL" border="0"></a></td>
  <td class="head"><h2>Public API Reference</h2></td>
 </tr>
 <tr height="11">
  <td colspan="2" class="headshadow" valign="top" style="padding-left:0;"><img src="celshadow.png" width="9" height="11" alt="" border="0"></td>
 </tr>
</table>
<div class="content">
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="hierarchy.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a>  </div>
  <div class="headertitle">
<div class="title">iCelGameFactory Struct Reference</div>  </div>
</div><!--header-->
<div class="contents">
<!-- doxytag: class="iCelGameFactory" --><!-- doxytag: inherits="iBase" -->
<p>A factory to manage game sessions.  
 <a href="structiCelGameFactory.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="network_8h_source.html">physicallayer/network.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for iCelGameFactory:</div>
<div class="dyncontent">
 <div class="center">
  <img src="structiCelGameFactory.png" usemap="#iCelGameFactory_map" alt=""/>
  <map id="iCelGameFactory_map" name="iCelGameFactory_map">
<area doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html" alt="iBase" shape="rect" coords="0,0,110,24"/>
</map>
 </div></div>

<p><a href="structiCelGameFactory-members.html">List of all members.</a></p>
<table class="memberdecls">
<tr><td colspan="2"><h2><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiCelGameFactory.html#a2c05f2035c8b36890cc1b054ffaddf79">CloseGame</a> ()=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">The player leaves the current game or playback.  <a href="#a2c05f2035c8b36890cc1b054ffaddf79"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiCelGameFactory.html#a47864202511ee8b1b082a713d6160160">ConnectGame</a> (<a class="el" href="classcelGameInfo.html">celGameInfo</a> *game_info, <a class="el" href="classcelPlayer.html">celPlayer</a> *player)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Connect the player to the game specified in game_info.  <a href="#a47864202511ee8b1b082a713d6160160"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiCelGameFactory.html#ab250a31bae2353686a1a86c0133b9717">CreateNewGame</a> (celNetworkGameType game_type, <a class="el" href="classcelGameInfo.html">celGameInfo</a> *game_info, <a class="el" href="classcelPlayer.html">celPlayer</a> *player=0)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Create a new game, ie at least a server, but also a client if a player is provided.  <a href="#ab250a31bae2353686a1a86c0133b9717"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="structiCelGame.html">iCelGame</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiCelGameFactory.html#a08d9669ad5b464d602b3c31365f6ae0c">GetCurrentGame</a> () const =0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Return the current game or 0 if no game is available.  <a href="#a08d9669ad5b464d602b3c31365f6ae0c"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual const char *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiCelGameFactory.html#a3997882a6993353c13208c58df38c928">GetGameName</a> () const =0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Return the name of the game.  <a href="#a3997882a6993353c13208c58df38c928"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual const char *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiCelGameFactory.html#a0d070b19ad4886d753dd44446eed2397">GetProtocolVersion</a> () const =0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Return the network protocol version used by this application.  <a href="#a0d070b19ad4886d753dd44446eed2397"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiCelGameFactory.html#acaf75baa0e49d7db41856abb3f3929db">RegisterGameFactoryManager</a> (<a class="el" href="classcelGameFactoryManager.html">celGameFactoryManager</a> *manager)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Register a manager for this game factory.  <a href="#acaf75baa0e49d7db41856abb3f3929db"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiCelGameFactory.html#ad9f141fd1a3d38edcc6b911adb9ea623">SetGameName</a> (const char *game_name)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Set the name of the game.  <a href="#ad9f141fd1a3d38edcc6b911adb9ea623"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiCelGameFactory.html#a4c123a0d396bb31715ad21eb53221275">SetProtocolVersion</a> (const char *protocol_version)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Set the name of the network protocol version used by this application.  <a href="#a4c123a0d396bb31715ad21eb53221275"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiCelGameFactory.html#a3994903c1501277c80ef87f66593eac5">StartPlayBackGame</a> (const char *filename, <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#ga28e82998c4c2d1197a1d412bba7da793">csTicks</a> start_time, <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#ga28e82998c4c2d1197a1d412bba7da793">csTicks</a> stop_time)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Start a game where incoming events are read from a file from start_time to stop_time.  <a href="#a3994903c1501277c80ef87f66593eac5"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiCelGameFactory.html#a9d5996c57a9c498fffdf27cf9acb9cb1">StartRecordingGame</a> (const char *filename)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Incoming events are recorded in a file.  <a href="#a9d5996c57a9c498fffdf27cf9acb9cb1"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiCelGameFactory.html#a7756c198de88c4b38ad29199dd92e1ca">StartSearchForGameList</a> (celNetworkGameType game_type, <a class="el" href="classcelGameInfo.html">celGameInfo</a> *filter=0)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Start to search for the list of available games with the same game name, protocol version and game type.  <a href="#a7756c198de88c4b38ad29199dd92e1ca"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiCelGameFactory.html#ac9e2167e6cf65890342941d91a0c5481">StopRecordingGame</a> ()=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Incoming events are no more recorded in a file.  <a href="#ac9e2167e6cf65890342941d91a0c5481"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiCelGameFactory.html#a22f040f0344983d25ebe5c1eeb9b8371">StopSearchForGameList</a> ()=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Stop searching for the list of available games.  <a href="#a22f040f0344983d25ebe5c1eeb9b8371"></a><br/></td></tr>
</table>
<hr/><a name="details" id="details"></a><h2>Detailed Description</h2>
<div class="textblock"><p>A factory to manage game sessions. </p>
<p>You can use it to:</p>
<ul>
<li>set and get the name of the game and of the network protocol version.</li>
<li>search for available games, connect to them or create a new game.</li>
<li>record the events of the game and playback them.</li>
</ul>
<p>You must define and register a iCelGameFactoryManager which will catch the events from this factory. </p>
<p>There should be only one game factory in an application. </p>

<p>Definition at line <a class="el" href="network_8h_source.html#l00098">98</a> of file <a class="el" href="network_8h_source.html">network.h</a>.</p>
</div><hr/><h2>Member Function Documentation</h2>
<a class="anchor" id="a2c05f2035c8b36890cc1b054ffaddf79"></a><!-- doxytag: member="iCelGameFactory::CloseGame" ref="a2c05f2035c8b36890cc1b054ffaddf79" args="()=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool <a class="el" href="structiCelGameFactory.html#a2c05f2035c8b36890cc1b054ffaddf79">iCelGameFactory::CloseGame</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>The player leaves the current game or playback. </p>
<p>If a server was also set, it will be closed. </p>
<dl class="return"><dt><b>Returns:</b></dt><dd>true if the game can be closed, false otherwise. </dd></dl>

</div>
</div>
<a class="anchor" id="a47864202511ee8b1b082a713d6160160"></a><!-- doxytag: member="iCelGameFactory::ConnectGame" ref="a47864202511ee8b1b082a713d6160160" args="(celGameInfo *game_info, celPlayer *player)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool <a class="el" href="structiCelGameFactory.html#a47864202511ee8b1b082a713d6160160">iCelGameFactory::ConnectGame</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classcelGameInfo.html">celGameInfo</a> *&#160;</td>
          <td class="paramname"><em>game_info</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classcelPlayer.html">celPlayer</a> *&#160;</td>
          <td class="paramname"><em>player</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Connect the player to the game specified in game_info. </p>
<p>If a game is already running, it will be closed before the new game is launched. The game_info field must contain the necessary data to find the server, ie a game_id field previously returned by <a class="el" href="classcelGameFactoryManager.html#a39c1ea28335081be506112b125b924b2" title="The game factory is searching for available games (it has been started with iCelGameFactory::StartSea...">celGameFactoryManager::GameInfoReceived</a>, or the ip_address and port_nb fields. If the game factory was searching for games, it will stop its search. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">game_info</td><td>the informations on the game we want to connect to. </td></tr>
    <tr><td class="paramname">player</td><td>the player which is connecting to the game. </td></tr>
  </table>
  </dd>
</dl>
<dl class="return"><dt><b>Returns:</b></dt><dd>true if the game can be connected. </dd></dl>

</div>
</div>
<a class="anchor" id="ab250a31bae2353686a1a86c0133b9717"></a><!-- doxytag: member="iCelGameFactory::CreateNewGame" ref="ab250a31bae2353686a1a86c0133b9717" args="(celNetworkGameType game_type, celGameInfo *game_info, celPlayer *player=0)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool <a class="el" href="structiCelGameFactory.html#ab250a31bae2353686a1a86c0133b9717">iCelGameFactory::CreateNewGame</a> </td>
          <td>(</td>
          <td class="paramtype">celNetworkGameType&#160;</td>
          <td class="paramname"><em>game_type</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classcelGameInfo.html">celGameInfo</a> *&#160;</td>
          <td class="paramname"><em>game_info</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classcelPlayer.html">celPlayer</a> *&#160;</td>
          <td class="paramname"><em>player</em> = <code>0</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Create a new game, ie at least a server, but also a client if a player is provided. </p>
<p>Only one game can be created at a time, so if a game is already running, it will be closed before the new game is launched. If the game factory was searching for games, it will stop its search. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">game_type</td><td>the type of the game. It can be CEL_NET_SINGLEPLAYER, CEL_NET_LOCAL or CEL_NET_PUBLIC. </td></tr>
    <tr><td class="paramname">game_info</td><td>the informations on the game. </td></tr>
    <tr><td class="paramname">player</td><td>the player launching the game. He can be given special access rights to modify the game. If player is different from 0, then a client will also be created. </td></tr>
  </table>
  </dd>
</dl>
<dl class="return"><dt><b>Returns:</b></dt><dd>true if the game can be created. </dd></dl>

</div>
</div>
<a class="anchor" id="a08d9669ad5b464d602b3c31365f6ae0c"></a><!-- doxytag: member="iCelGameFactory::GetCurrentGame" ref="a08d9669ad5b464d602b3c31365f6ae0c" args="() const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="structiCelGame.html">iCelGame</a>* <a class="el" href="structiCelGameFactory.html#a08d9669ad5b464d602b3c31365f6ae0c">iCelGameFactory::GetCurrentGame</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Return the current game or 0 if no game is available. </p>

</div>
</div>
<a class="anchor" id="a3997882a6993353c13208c58df38c928"></a><!-- doxytag: member="iCelGameFactory::GetGameName" ref="a3997882a6993353c13208c58df38c928" args="() const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual const char* <a class="el" href="structiCelGameFactory.html#a3997882a6993353c13208c58df38c928">iCelGameFactory::GetGameName</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Return the name of the game. </p>
<p>Client and server instances can talk together only if they have the same game name and protocol version. </p>

</div>
</div>
<a class="anchor" id="a0d070b19ad4886d753dd44446eed2397"></a><!-- doxytag: member="iCelGameFactory::GetProtocolVersion" ref="a0d070b19ad4886d753dd44446eed2397" args="() const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual const char* <a class="el" href="structiCelGameFactory.html#a0d070b19ad4886d753dd44446eed2397">iCelGameFactory::GetProtocolVersion</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Return the network protocol version used by this application. </p>
<p>Client and server instances can talk together only if they have the same game name and protocol version. </p>

</div>
</div>
<a class="anchor" id="acaf75baa0e49d7db41856abb3f3929db"></a><!-- doxytag: member="iCelGameFactory::RegisterGameFactoryManager" ref="acaf75baa0e49d7db41856abb3f3929db" args="(celGameFactoryManager *manager)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiCelGameFactory.html#acaf75baa0e49d7db41856abb3f3929db">iCelGameFactory::RegisterGameFactoryManager</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classcelGameFactoryManager.html">celGameFactoryManager</a> *&#160;</td>
          <td class="paramname"><em>manager</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Register a manager for this game factory. </p>
<p>The manager will be notified when events are thrown from the game factory. Only one manager can be registered at a time. </p>
<p>A manager must be registered before any operation on the factory. </p>

</div>
</div>
<a class="anchor" id="ad9f141fd1a3d38edcc6b911adb9ea623"></a><!-- doxytag: member="iCelGameFactory::SetGameName" ref="ad9f141fd1a3d38edcc6b911adb9ea623" args="(const char *game_name)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiCelGameFactory.html#ad9f141fd1a3d38edcc6b911adb9ea623">iCelGameFactory::SetGameName</a> </td>
          <td>(</td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>game_name</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Set the name of the game. </p>
<p>Client and server instances can talk together only if they have the same game name and protocol version. </p>
<p>A game name must be set before any operation on the factory. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">game_name</td><td>an arbitrary game name, like "Crystal Core". </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a4c123a0d396bb31715ad21eb53221275"></a><!-- doxytag: member="iCelGameFactory::SetProtocolVersion" ref="a4c123a0d396bb31715ad21eb53221275" args="(const char *protocol_version)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiCelGameFactory.html#a4c123a0d396bb31715ad21eb53221275">iCelGameFactory::SetProtocolVersion</a> </td>
          <td>(</td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>protocol_version</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Set the name of the network protocol version used by this application. </p>
<p>Client and server instances can talk together only if they have the same game name and protocol version. </p>
<p>A protocol version must be set before any operation on the factory. </p>
<p>The protocol version should be changed each time something has been changed in the network protocol of the game, ie in the meaning of the network events, like changes in the implementation of the network plugin, the selection of property classes of the entities, the client and server events, the network links and the baselines. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">protocol_version</td><td>an arbitrary protocol version name, like "v0.3". </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a3994903c1501277c80ef87f66593eac5"></a><!-- doxytag: member="iCelGameFactory::StartPlayBackGame" ref="a3994903c1501277c80ef87f66593eac5" args="(const char *filename, csTicks start_time, csTicks stop_time)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiCelGameFactory.html#a3994903c1501277c80ef87f66593eac5">iCelGameFactory::StartPlayBackGame</a> </td>
          <td>(</td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>filename</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#ga28e82998c4c2d1197a1d412bba7da793">csTicks</a>&#160;</td>
          <td class="paramname"><em>start_time</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#ga28e82998c4c2d1197a1d412bba7da793">csTicks</a>&#160;</td>
          <td class="paramname"><em>stop_time</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Start a game where incoming events are read from a file from start_time to stop_time. </p>
<p>CloseGame can be used to stop the playback. If the game factory was searching for available games or if a game was running, they will be stopped. </p>

</div>
</div>
<a class="anchor" id="a9d5996c57a9c498fffdf27cf9acb9cb1"></a><!-- doxytag: member="iCelGameFactory::StartRecordingGame" ref="a9d5996c57a9c498fffdf27cf9acb9cb1" args="(const char *filename)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiCelGameFactory.html#a9d5996c57a9c498fffdf27cf9acb9cb1">iCelGameFactory::StartRecordingGame</a> </td>
          <td>(</td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>filename</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Incoming events are recorded in a file. </p>
<p>A game must previously be running. </p>

</div>
</div>
<a class="anchor" id="a7756c198de88c4b38ad29199dd92e1ca"></a><!-- doxytag: member="iCelGameFactory::StartSearchForGameList" ref="a7756c198de88c4b38ad29199dd92e1ca" args="(celNetworkGameType game_type, celGameInfo *filter=0)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiCelGameFactory.html#a7756c198de88c4b38ad29199dd92e1ca">iCelGameFactory::StartSearchForGameList</a> </td>
          <td>(</td>
          <td class="paramtype">celNetworkGameType&#160;</td>
          <td class="paramname"><em>game_type</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classcelGameInfo.html">celGameInfo</a> *&#160;</td>
          <td class="paramname"><em>filter</em> = <code>0</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Start to search for the list of available games with the same game name, protocol version and game type. </p>
<p>The registered <a class="el" href="classcelGameFactoryManager.html" title="This is an interface you should implement in order to manage the events from the factory of game sess...">celGameFactoryManager</a> will be notified through <a class="el" href="classcelGameFactoryManager.html#a39c1ea28335081be506112b125b924b2" title="The game factory is searching for available games (it has been started with iCelGameFactory::StartSea...">celGameFactoryManager::GameInfoReceived</a> each time a game has been found. A <a class="el" href="classcelGameInfo.html" title="General information on a game.">celGameInfo</a> object can be provided to filter the games. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">filter</td><td>a new game info will be received only if <a class="el" href="classcelGameInfo.html#a7656bd23a74fccfa2687cca1b800c20e" title="Return true if this game info matches the filter, false otherwise.">celGameInfo::MatchFilter</a> returns true with this filter. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="ac9e2167e6cf65890342941d91a0c5481"></a><!-- doxytag: member="iCelGameFactory::StopRecordingGame" ref="ac9e2167e6cf65890342941d91a0c5481" args="()=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiCelGameFactory.html#ac9e2167e6cf65890342941d91a0c5481">iCelGameFactory::StopRecordingGame</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Incoming events are no more recorded in a file. </p>

</div>
</div>
<a class="anchor" id="a22f040f0344983d25ebe5c1eeb9b8371"></a><!-- doxytag: member="iCelGameFactory::StopSearchForGameList" ref="a22f040f0344983d25ebe5c1eeb9b8371" args="()=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiCelGameFactory.html#a22f040f0344983d25ebe5c1eeb9b8371">iCelGameFactory::StopSearchForGameList</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Stop searching for the list of available games. </p>
<p>No more <a class="el" href="classcelGameFactoryManager.html#a39c1ea28335081be506112b125b924b2" title="The game factory is searching for available games (it has been started with iCelGameFactory::StartSea...">celGameFactoryManager::GameInfoReceived</a> will be raised. </p>

</div>
</div>
<hr/>The documentation for this struct was generated from the following file:<ul>
<li>physicallayer/<a class="el" href="network_8h_source.html">network.h</a></li>
</ul>
</div><!-- contents -->
<hr size="1"><address><small>Generated for CEL: Crystal Entity Layer 2.0 by 
<a href="http://www.doxygen.org/index.html">doxygen</a> 1.7.6.1 
</small></address> </div></body> </html>
